#define APPNAME  "test - directx"
#define APPTITLE "test - directx"

template<class T> void _RELEASE_(T t)
{
	if( t )
	{
		t->Release();
		t = 0;
	}
}

template<class T> void _DELETE_(T t)
{
	if( t )
	{
		delete t;
		t = 0;
	}
}

#define		PI					(3.1415926)
#define		DEGtoRAD(x)			(float)((float)x * PI / 180.0f)

#include <windows.h>
#include <time.h>
#include <stdio.h>

#include <d3d9.h>
#include <d3dx9.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")
#pragma comment (lib, "winmm.lib")

//ؽ ü Ÿ 
struct CUSTOMVERTEX { 
	float x, y, z; 
	DWORD color; 
	float tu, tv;
};

#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)

LPDIRECT3DTEXTURE9 g_pTexture = NULL;


bool g_bIsFullScreen = false;	        // is our app Full screen or not
int g_iScreenX = 640, g_iScreenY = 480;	// use this if 'not'
D3DDISPLAYMODE  g_d3ddm = {640, 480, 60, D3DFMT_A8R8G8B8};


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;

LPDIRECT3D9             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE9       g_d3d_Device = NULL; // our d3d8 device
LPDIRECT3DVERTEXBUFFER9 g_VertexBuffer = NULL; // our VertexBuffer
D3DPRESENT_PARAMETERS	g_d3dpp; 


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
void SetupCamera(HWND hWnd);
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D();
void	DestroyDirect3D8();

bool LoadTextureFromBMP(LPCSTR str, LPDIRECT3DTEXTURE9 *ppTexture);
void FillRed();

//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		return 0;
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		else if (wParam == VK_F1)
		    FillRed();
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	case WM_SYSCOMMAND:
		// Prevent moving/sizing and power loss in fullscreen mode
		switch( wParam )
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				if( g_bIsFullScreen)
					return 1;
				break;
		}
		break;

    case WM_NCHITTEST:
       // Prevent the user from selecting the menu in fullscreen mode
        if(g_bIsFullScreen)
              return HTCLIENT;
        break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		return 0;
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	if(g_bIsFullScreen)
	{
		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_POPUP|WS_SYSMENU|WS_VISIBLE, 
			0, 0, 
			g_d3ddm.Width,
			g_d3ddm.Height,
			NULL,
			NULL,
			hInst,
			NULL);
	}
	else
	{
		int sx = GetSystemMetrics (SM_CXSCREEN);
		int sy = GetSystemMetrics (SM_CYSCREEN);

		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_OVERLAPPED | WS_SYSMENU,
			sx/2 - g_iScreenX/2, sy/2 - g_iScreenY/2,
			g_iScreenX,
			g_iScreenY,
			NULL,
			NULL,
			hInst,
			NULL);
	};

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
    
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	ZeroMemory (&g_d3dpp, sizeof(g_d3dpp));

    if( NULL == ( g_d3d = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	//ؽ ó 
	D3DCAPS9 caps;
	D3DDEVTYPE deviceType = D3DDEVTYPE_HAL;
	g_d3d->GetDeviceCaps(D3DADAPTER_DEFAULT, deviceType, &caps);
	int vertexProcessing = 0;
	if( caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT )
		vertexProcessing = D3DCREATE_HARDWARE_VERTEXPROCESSING;
	else
		vertexProcessing = D3DCREATE_SOFTWARE_VERTEXPROCESSING;

	if(g_bIsFullScreen)
	{
		g_d3dpp.BackBufferWidth = g_d3ddm.Width;
		g_d3dpp.BackBufferHeight = g_d3ddm.Height;
		g_d3dpp.BackBufferCount = 1;
		g_d3dpp.FullScreen_RefreshRateInHz = g_d3ddm.RefreshRate; //D3DPRESENT_RATE_DEFAULT
	    g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		if( FAILED( g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm)))
			return E_FAIL;
	}

    g_d3dpp.Windowed = !g_bIsFullScreen;
    g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    g_d3dpp.BackBufferFormat = g_d3ddm.Format;
	g_d3dpp.hDeviceWindow              = g_hWnd;
	g_d3dpp.EnableAutoDepthStencil     = true; 
	g_d3dpp.AutoDepthStencilFormat     = D3DFMT_D24S8;

    if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   vertexProcessing, 
								   &g_d3dpp, &g_d3d_Device)))
	{
		return E_FAIL;
	}

	//g_d3d_Device->SetRenderState( D3DRS_ZENABLE, TRUE );
	//g_d3d_Device->SetRenderState( D3DRS_AMBIENT, 0xffffffff );
	g_d3d_Device->SetRenderState( D3DRS_LIGHTING, FALSE );
	g_d3d_Device->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	return S_OK;
}
//-----------------------------------------------------------------------------
void SetupCamera(HWND hWnd)
{
    D3DXMATRIX   matProj;
	D3DXMATRIX	 matCameraView;
	D3DXVECTOR3  cameraTarget;
    D3DXVECTOR3  cameraPos;

	// Set where camera is viewing from
	cameraPos.x = 0.0f;
	cameraPos.y = 0.0f;
	cameraPos.z = -10.0f;
	// Set what camera is looking at
	cameraTarget.x = 0.0f;
	cameraTarget.y = 0.0f;
	cameraTarget.z = 0.0f;

	// Setup Camera View
	D3DXMatrixLookAtLH( &matCameraView, 
						&cameraPos, 
						&cameraTarget, 
						&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	// Tell the device to use the camera view for the viewport
	g_d3d_Device->SetTransform( D3DTS_VIEW, &matCameraView );

	// Setup Projection 
	RECT rect;
	GetClientRect(hWnd, &rect);
	float width = (float)rect.right, height = (float)rect.bottom;
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, width/height, 1.0f, 100.0f );
	// Tell the device to use the above matrix for projection
	g_d3d_Device->SetTransform( D3DTS_PROJECTION, &matProj );
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	float	fSizeX = 5.0f;
	float	fSizeY = 5.0f;
	
	CUSTOMVERTEX	vertex[4];

	// Create the geometry
	vertex[0].x = -fSizeX/2;
	vertex[0].y = -fSizeY/2;
	vertex[0].z = 0.0f;
	vertex[0].color = 0xffffff;
	vertex[0].tu = 0.0f;
    vertex[0].tv = 1.0f;
	
	vertex[1].x = -fSizeX/2;
	vertex[1].y = fSizeY/2;
	vertex[1].z = 0.0f;
	vertex[1].color = 0xffffff;
	vertex[1].tu = 0.0f;
    vertex[1].tv = 0.0f;

	vertex[2].x = fSizeX/2;
	vertex[2].y = -fSizeY/2;
	vertex[2].z = 0.0f;
	vertex[2].color = 0xffffff;
	vertex[2].tu = 1.0f;
    vertex[2].tv = 1.0f;
	
	vertex[3].x = fSizeX/2;
	vertex[3].y = fSizeY/2;
	vertex[3].z = 0.0f;
	vertex[3].color = 0xffffff;
	vertex[3].tu = 1.0f;
    vertex[3].tv = 0.0f;
	
	g_d3d_Device->CreateVertexBuffer (4*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_MANAGED, &g_VertexBuffer, NULL);
	
	VOID* pVertices;
	g_VertexBuffer->Lock (0, sizeof(vertex), &pVertices, 0);
    memcpy (pVertices, vertex, sizeof(vertex));
    g_VertexBuffer->Unlock();

	if(LoadTextureFromBMP("texture.bmp", &g_pTexture) == false)
		return  false;
#if  0
	//Į Ѵ.  ̴
	DWORD dwColor = 0xffff0000;    //B,G,R,AƮ  ȴ. DWORD ϸ ݴ̴.
	g_d3d_Device->SetRenderState(D3DRS_TEXTUREFACTOR,dwColor);
	g_d3d_Device->SetTextureStageState(0,D3DTSS_COLOROP,D3DTOP_MODULATE); //ARG1ARG2 Įġ  Įġ մϴ. 
	g_d3d_Device->SetTextureStageState(0,D3DTSS_COLORARG1,D3DTA_TEXTURE); //texture Įġ
	g_d3d_Device->SetTextureStageState(0,D3DTSS_COLORARG2,D3DTA_TFACTOR); // Įġ
#endif 	

#if  0
	//Ӱ .   D3DTOP_SUBTRACT D3DTOP_ADD Ѵ.
	g_d3d_Device->SetRenderState(D3DRS_TEXTUREFACTOR , 0xff505050); 
	g_d3d_Device->SetTextureStageState(0, D3DTSS_COLOROP , D3DTOP_SUBTRACT ); 
	g_d3d_Device->SetTextureStageState(0, D3DTSS_COLORARG1 , D3DTA_TEXTURE ); 
	g_d3d_Device->SetTextureStageState(0, D3DTSS_COLORARG2 , D3DTA_TFACTOR ); 
#endif

#if  1
	g_d3d_Device->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE ); 
	g_d3d_Device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA); 
	g_d3d_Device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); 

	DWORD dwColor = 0x030000000;    //A,R,G,B() Ͱ  ֱ ()
	g_d3d_Device->SetRenderState(D3DRS_TEXTUREFACTOR,dwColor);
	g_d3d_Device->SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_MODULATE); //ARG1ARG2ǥᰪ إᰪ մϴ. 
	g_d3d_Device->SetTextureStageState(0,D3DTSS_ALPHAARG1,D3DTA_TEXTURE); //texture Įġ
	g_d3d_Device->SetTextureStageState(0,D3DTSS_ALPHAARG2,D3DTA_TFACTOR); // Įġ
#endif 
	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8()
{
	_RELEASE_<LPDIRECT3DTEXTURE9>(g_pTexture);
	_RELEASE_<LPDIRECT3DVERTEXBUFFER9>(g_VertexBuffer);
	_RELEASE_<LPDIRECT3DDEVICE9>(g_d3d_Device);
	_RELEASE_<LPDIRECT3D9>(g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT ResetDeviceObjects()
{
	HRESULT hr;

    // Release all vidmem objects
    //if( FAILED( hr = InvalidateDeviceObjects() ) )
    //    return hr;

	// Reset the device
	if( FAILED( hr = g_d3d_Device->Reset( &g_d3dpp ) ) )
		return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    HRESULT hr;

    // Test the cooperative level to see if it's okay to render
    if( FAILED( hr = g_d3d_Device->TestCooperativeLevel() ) )
    {
        // If the device was lost, do not render until we get it back
        if( D3DERR_DEVICELOST == hr )
            return S_OK;

        // Check if the device needs to be resized.
        if( D3DERR_DEVICENOTRESET == hr )
        {
            // If we are windowed, read the desktop mode and use the same format for
            // the back buffer
            if( !g_bIsFullScreen )
            {
				g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm);
                g_d3dpp.BackBufferFormat = g_d3ddm.Format;
            }

            if( FAILED( hr = ResetDeviceObjects() ) )
                return hr;
        }
        return hr;
    }

    // Render the scene as normal
    if( FAILED( hr = Render3D() ) )
        return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT Render3D ()
{
	//ȸ
	static	float	angle = 0.0f;
	D3DXMATRIX	matWorld;
	D3DXMatrixRotationY(&matWorld, DEGtoRAD(angle));
	angle += 1.0f;
	g_d3d_Device->SetTransform(D3DTS_WORLD, &matWorld);

	//帵
	HRESULT hr;
    g_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB (0, 0, 255), 1.0f, 0);
    g_d3d_Device->BeginScene ();

	g_d3d_Device->SetTexture( 0, g_pTexture );

    g_d3d_Device->SetFVF (D3DFVF_CUSTOMVERTEX);
    g_d3d_Device->SetStreamSource (0, g_VertexBuffer, 0, sizeof(CUSTOMVERTEX));
    g_d3d_Device->DrawPrimitive (D3DPT_TRIANGLESTRIP, 0, 2);

    g_d3d_Device->EndScene ();
    hr = g_d3d_Device->Present (NULL, NULL, NULL, NULL);
	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	SetupCamera(g_hWnd);

	if(!RenderInit())
		return -1;

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------
int MultiplyTwo(int num)
{
	int i = 1;
	while(i < num)
		i *= 2;

	return i;
}
//-----------------------------------------------------------------------------
bool LoadTextureFromBMP(LPCSTR str, LPDIRECT3DTEXTURE9 *ppTexture)
{
	LPDIRECT3DSURFACE9	surface;
	BITMAPFILEHEADER	bFile;
	BITMAPINFOHEADER	bInfo;
	D3DLOCKED_RECT	    rect;
	DWORD	w, h;
	INT		x, y;
	LPDWORD	data;
	FILE	*fp = NULL;

	*ppTexture = NULL;

	fp = fopen(str, "rb");

	//BMP     д´.
	fread(&bFile, sizeof(BITMAPFILEHEADER), 1, fp);
	fread(&bInfo, sizeof(BITMAPINFOHEADER), 1, fp);

	//24bit ȼ Ѵ.
	if(bInfo.biBitCount != 24)
		goto error;

	//ؽ  2 ¼ .
	w = MultiplyTwo(bInfo.biWidth);
	h = MultiplyTwo(bInfo.biHeight);

	//ؽĸ .
	if(FAILED(g_d3d_Device->CreateTexture(w, h, 0, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, ppTexture, NULL)))
		goto error;

	//Surface ´.
	if(FAILED((*ppTexture)->GetSurfaceLevel(0, &surface)))
		goto error;

	surface->LockRect(&rect, NULL, 0); //D3DLOCK_DISCARD);
	
	//BMP Ÿ ġ ̵Ѵ.
	fseek(fp, bFile.bfOffBits, SEEK_SET);

	//BMP Ÿ īѴ(Ʈ Ʒ ݴ Ǳ  Ʒ Ѵ)
	for(y=(int)bInfo.biHeight-1; y>=0; y--)
	{
		//Y  ġ ̵Ѵ.
		data = (LPDWORD)((LPBYTE)rect.pBits + rect.Pitch * y);

		for(x=0; x<bInfo.biWidth; x++, data++)
		{
			BYTE	r, g, b;
			fread(&b, sizeof(BYTE), 1, fp);
			fread(&g, sizeof(BYTE), 1, fp);
			fread(&r, sizeof(BYTE), 1, fp);

			// Į surface ִ´.
			*data = 0xff000000 | ((DWORD)r << 16) | ((DWORD)g << 8) | ((DWORD)b);
		}
	}

	//surface  Ǭ.
	surface->UnlockRect();

	//surface ޸𸮸 Ѵ.
	_RELEASE_<LPDIRECT3DSURFACE9>(surface);	

	//  ڵ ݴ´.
	fclose(fp);

	return true;

error:
	if(*ppTexture)
		_RELEASE_<LPDIRECT3DTEXTURE9>(*ppTexture); 
	if(fp)
		 fclose(fp);
	return false;
}

void FillRed()
{
	//32-Ʈ ȼ  ̿Ѵٰ Ѵ.
	//Surface ´.
	LPDIRECT3DSURFACE9	_surface;
	D3DLOCKED_RECT      lockedRect;

	if(FAILED(g_pTexture->GetSurfaceLevel(0, &_surface)))
		return;

    //ǥ  ´.
	D3DSURFACE_DESC surfaceDesc;
	_surface->GetDesc(&surfaceDesc);

	//ǥ ȼ ͷ ͸ ´.
	_surface->LockRect(
		&lockedRect, // ͸  
		0,           //ü ǥ ٴ.
		0);          // ׸  ʴ´.

	//ǥ  ȼ  ݺϿ ȼ  Ѵ.
	DWORD* imageData = (DWORD*)lockedRect.pBits;
	for(int i = 0; i < (int)surfaceDesc.Height; i++)
	{
		for(int j = 0; j < (int)surfaceDesc.Width; j++)
		{
			//ġ Ʈ ̸ DWORD  4Ʈ̹Ƿ
			//ġ 4  ϶.
			int index = i * lockedRect.Pitch / 4 + j;

			imageData[index] = 0xffff0000; //red
		}
	}

	_surface->UnlockRect();

	//surface ޸𸮸 Ѵ.
	_RELEASE_<LPDIRECT3DSURFACE9>(_surface);	
}
